---
title: 'CSP: upgrade-insecure-requests'
slug: Web/HTTP/Headers/Content-Security-Policy/upgrade-insecure-requests
tags:
  - CSP
  - Content-Security-Policy
  - Directive
  - HTTP
  - Reference
  - Requests
  - Security
  - Upgrade
  - upgrade-insecure-requests
---
<div>{{HTTPSidebar}}</div>

<p>The HTTP {{HTTPHeader("Content-Security-Policy")}} (CSP) <code><strong>upgrade-insecure-requests</strong></code> directive instructs user agents to treat all of a site's insecure URLs (those served over HTTP) as though they have been replaced with secure URLs (those served over HTTPS). This directive is intended for web sites with large numbers of insecure legacy URLs that need to be rewritten.</p>

<p class="note">The <code>upgrade-insecure-requests</code> directive is evaluated before {{CSP("block-all-mixed-content")}} and if it is set, the latter is effectively a no-op. It is recommended to set either directive, but not both, unless you want to force HTTPS on older browsers that do not force it after a redirect to HTTP.</p>

<p>The <code>upgrade-insecure-requests</code> directive will not ensure that users visiting your site via links on third-party sites will be upgraded to HTTPS for the top-level navigation and thus does not replace the {{HTTPHeader("Strict-Transport-Security")}} ({{Glossary("HSTS")}}) header, which should still be set with an appropriate <code>max-age</code> to ensure that users are not subject to SSL stripping attacks.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">Content-Security-Policy: upgrade-insecure-requests;</pre>

<h2 id="Examples">Examples</h2>

<pre>// header
Content-Security-Policy: upgrade-insecure-requests;

// meta tag
&lt;meta http-equiv="Content-Security-Policy" content="upgrade-insecure-requests"&gt;
</pre>

<p>With the above header set on a domain example.com that wants to migrate from HTTP to HTTPS, non-navigational insecure resource requests are automatically upgraded (first-party as well as third-party requests).</p>

<pre class="brush: html">&lt;img src="http://example.com/image.png"&gt;
&lt;img src="http://not-example.com/image.png"&gt;</pre>

<p>These URLs will be rewritten before the request is made, meaning that no insecure requests will hit the network. Note that, if the requested resource is not actually available via HTTPS, the request will fail without any fallback to HTTP.</p>

<pre class="brush: html">&lt;img src="https://example.com/image.png"&gt;
&lt;img src="https://not-example.com/image.png"&gt;</pre>

<p>Navigational upgrades to third-party resources brings a significantly higher potential for breakage, these are not upgraded:</p>

<pre class="brush: html">&lt;a href="https://example.com/"&gt;Home&lt;/a&gt;
&lt;a href="http://not-example.com/"&gt;Home&lt;/a&gt;</pre>

<h3 id="Finding_insecure_requests">Finding insecure requests</h3>

<p>With the help of the {{HTTPHeader("Content-Security-Policy-Report-Only")}} header and the {{CSP("report-uri")}} directive, you can set-up an enforced policy and a reported policy like this:</p>

<pre>Content-Security-Policy: upgrade-insecure-requests; default-src https:
Content-Security-Policy-Report-Only: default-src https:; report-uri /endpoint</pre>

<p>That way, you still upgrade insecure requests on your secure site, but the only monitoring policy is violated and reports insecure resources to your endpoint.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
	<tbody>
		<tr>
			<th scope="col">Specification</th>
			<th scope="col">Status</th>
			<th scope="col">Comment</th>
		</tr>
		<tr>
			<td>{{specName("Upgrade Insecure Requests", "#delivery", "upgrade-insecure-requests")}}</td>
			<td>{{Spec2('Upgrade Insecure Requests')}}</td>
			<td>Initial definition.</td>
		</tr>
	</tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p class="hidden">The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>

<p>{{Compat("http.headers.csp.Content-Security-Policy.upgrade-insecure-requests")}}</p>

<h2 id="See_also">See also</h2>

<ul>
	<li>{{HTTPHeader("Content-Security-Policy")}}</li>
	<li>{{HTTPHeader("Upgrade-Insecure-Requests")}} header</li>
	<li>{{HTTPHeader("Strict-Transport-Security")}} ({{Glossary("HSTS")}}) header</li>
	<li>{{CSP("block-all-mixed-content")}}</li>
	<li><a href="/en-US/docs/Web/Security/Mixed_content">Mixed content</a></li>
</ul>
